<template>
    <TableHeader datePicker nextFlag theCurrentTime showTimeAll ref="TableHeaderRef" showExport showCustomColumn>
        <template #select>
            <el-form-item label="项目名称">
                <el-input v-model="tableStore.table.params.projectName" placeholder="请输入项目名称" maxlength="32" show-word-limit clearable></el-input>
            </el-form-item>
            <el-form-item label="所在地市">
                <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所在地市" filterable>
                    <el-option
                        v-for="item in areaOptionList"
                        :key="item.id"
                        :label="item.name"
                        :value="item.name"
                    ></el-option>
                </el-select>
            </el-form-item>

            <el-form-item label="流程状态">
                <el-select v-model="tableStore.table.params.status" clearable placeholder="请选择流程状态" filterable>
                    <el-option
                        v-for="item in statusSelect"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    ></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <!-- <el-button icon="el-icon-Plus" type="primary" @click="addList">新增</el-button> -->
            <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button>
            <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
            <!-- <el-button icon="el-icon-Download" @click="exportEvent" type="primary">导出</el-button> -->
        </template>
    </TableHeader>
    <Table ref="tableRef" :checkbox-config="checkboxConfig" />
    <!-- 新增 -->
    <Add ref="addRef" @onSubmit="tableStore.index()" />
    <!-- 上传 -->
    <Audit ref="AuditRef" @onSubmit="tableStore.index()" />
    <!-- 查看详情 detail 新增/修改 create-->
    <addForm ref="addForms" @onSubmit="tableStore.index()"></addForm>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, watch, reactive } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import Add from './add.vue'
import Audit from './audit.vue'
import addForm from './addForm.vue'
import { useDictData } from '@/stores/dictData'
import { getLoadTypeUserList } from '@/api/process-boot/interference'
import { cancelFormData, getUserReportById } from '@/api/supervision-boot/interfere/index'
import { ElMessage, ElMessageBox } from 'element-plus'
import { useAdminInfo } from '@/stores/adminInfo'
import { deleteUserReport } from '@/api/supervision-boot/delete/index'

//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const dictData = useDictData()
const { push, options, currentRoute } = useRouter()
const TableHeaderRef = ref()
const tableRef = ref()
const areaOptionList = dictData
    .getBasicData('jibei_area')
    .filter(item => !(item.name == '超高压' || item.name == '风光储'))
const statusSelect = dictData.statusSelect()
const addRef = ref()
const AuditRef = ref()
const ruleFormRef = ref()
const show: any = ref(false)
const fileList = ref([])
const flag = ref(false)
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getUserReport',
    publicHeight: 65,
    method: 'POST',
    filename: '未建档用户档案录入管理',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        {
            title: '序号',
            width: 80,
            formatter: (row: any) => {
                return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
            }
        },
        // { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'city',
            title: '所在地市',
            minWidth: 80
            // formatter: (obj: any) => {
            //     return areaOptionList.filter(item => item.id == obj.row.city)[0]?.name
            // }
        },
        {
            field: 'substation',
            title: '厂站名称',
            minWidth: 100,
            formatter: (row: any) => {
                row.cellValue = row.cellValue ? row.cellValue : '/'
                return row.cellValue
            }
        },
        { field: 'projectName', title: '项目名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        {
            field: 'status',
            title: '流程状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        { field: 'createTime', title: '开始时间', minWidth: 170 },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: 150,
         
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return !row.processInstanceId
                    },
                    click: row => {
                        flag.value = true
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 0)
                    },
                    disabled: row => {
                        return !(row.status == 0)
                    },
                    click: row => {
                        addForms.value.open({
                            title: '编辑',
                            row: row
                        })
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        addForms.value.open({
                            title: '重新发起',
                            row: row
                        })
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                },
                {
                    name: 'cancel',
                    title: '二级评估',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.secondAssessmentId == null
                    },
                    click: row => {
                        push({
                            name: 'runManage/assessment',
                            query: {
                                type: '2',
                                secondAssessmentId:row.secondAssessmentId,
                                t: Date.now()
                            }
                        })
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    },
    exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.userStatus =
                item.userStatus == 0 ? '可研' : item.userStatus == 1 ? '建设' : item.userStatus == 2 ? '运行' : '退运'
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : '已取消'
            return item
        })
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.fileUploadflag = ''
tableStore.table.params.orgId = adminInfo.$state.deptId
tableStore.table.params.status = ''

provide('tableStore', tableStore)
// 新增
const addList = () => {
    addRef.value.open()
}
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {
        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        }).then(() => {
            deleteUserReport(tableStore.table.selection.map(item => item.id)).then(res => {
                ElMessage({
                    type: 'success',
                    message: '删除成功!'
                })
                tableStore.index()
            })
        })
    }
}

const addForms = ref()
const addFormModel = () => {
    show.value = true
    setTimeout(() => {
        addForms.value.open({
            title: '用户档案录入'
        })
    }, 0)
}

// 导出
const exportEvent = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    getLoadTypeUserList(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '未建档非线性用户', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancelFormData(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}

onMounted(() => {
    tableStore.index()
})
watch(
    () => currentRoute.value.path,
    () => {
        if (flag.value && options.history.state.forward?.split('/')[1] == 'bpm') {
            tableStore.index()
            flag.value = false
        }
    },
    {
        deep: true
    }
)

/** 处理审批按钮 */
const handleAudit = (instanceId: any, historyInstanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}

const props = defineProps({ id: { type: String, default: 'null' } })
watch(
    () => props.id,
    async (newValue, oldValue) => {
        if (newValue === 'null') return // 直接返回，避免后续逻辑执行
        const fullId = newValue.split('@')[0]
        let nowTime = Date.now()
        const routeTime = Number(newValue.split('@')[1])
        if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
        await getUserReportById(fullId).then(res => {
            if (res && res.code == 'A0000') {
                addForms.value.open({
                    title: '重新发起',
                    row: res.data
                })
            }
        })
    },
    { immediate: true }
)
</script>

<style scoped lang="scss"></style>
